Index: roard/Makefile
===================================================================
--- roard/Makefile	(revision 1515)
+++ roard/Makefile	(revision 1543)
@@ -2,5 +2,5 @@
 
 OBJ=roard.o driver.o mixer.o output.o signals.o loop.o clients.o streams.o network.o commands.o req.o sources.o sample.o meta.o codecfilter.o midi.o lib.o
-DRV=driver_esd.o driver_ao.o driver_roar.o driver_raw.o driver_oss.o driver_shout.o
+DRV=driver_esd.o driver_ao.o driver_roar.o driver_raw.o driver_oss.o driver_shout.o driver_sndio.o
 CF=codecfilter_cmd.o codecfilter_vorbis.o codecfilter_celt.o codecfilter_speex.o codecfilter_wave.o codecfilter_alaw.o codecfilter_mulaw.o codecfilter_sndfile.o codecfilter_fishsound.o
 
Index: roard/driver.c
===================================================================
--- roard/driver.c	(revision 1478)
+++ roard/driver.c	(revision 1543)
@@ -45,4 +45,7 @@
 #ifdef ROAR_HAVE_LIBSHOUT
  {"shout", "libshout streaming", "http://user:pw@host:port/mount.ogg", NULL, driver_shout_close, NULL, NULL, NULL, NULL, driver_shout_open_vio},
+#endif
+#ifdef ROAR_HAVE_LIBSNDIO
+ {"sndio", "OpenBSD sndio", "/dev/audio, /tmp/aucat-<uid>/default", NULL, NULL, NULL, NULL, NULL, NULL, driver_sndio_open},
 #endif
  {NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL} // end of list
Index: roard/driver_sndio.c
===================================================================
--- roard/driver_sndio.c	(revision 1543)
+++ roard/driver_sndio.c	(revision 1543)
@@ -0,0 +1,34 @@
+//driver_sndio.c:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *
+ *  This file is part of roard a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+
+#include "roard.h"
+#ifdef ROAR_HAVE_LIBSNDIO
+
+int driver_sndio_open(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh) {
+ return -1;
+}
+
+#endif
+
+//ll
Index: roard/include/driver.h
===================================================================
--- roard/include/driver.h	(revision 1175)
+++ roard/include/driver.h	(revision 1543)
@@ -67,4 +67,9 @@
 #endif
 
+#ifdef ROAR_HAVE_LIBSNDIO
+#include <sndio.h>
+#include "driver_sndio.h"
+#endif
+
 #if defined(ROAR_HAVE_OSS_BSD) || defined(ROAR_HAVE_OSS)
 #if defined(__OpenBSD__) || defined(__NetBSD__)
Index: roard/include/driver_sndio.h
===================================================================
--- roard/include/driver_sndio.h	(revision 1543)
+++ roard/include/driver_sndio.h	(revision 1543)
@@ -0,0 +1,36 @@
+//driver_sndio.h:
+
+/*
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2009
+ *
+ *  This file is part of roard a part of RoarAudio,
+ *  a cross-platform sound system for both, home and professional use.
+ *  See README for details.
+ *
+ *  This file is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License version 3
+ *  as published by the Free Software Foundation.
+ *
+ *  RoarAudio is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this software; see the file COPYING.  If not, write to
+ *  the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
+ *
+ */
+
+#ifndef _DRIVER_SNDIO_H_
+#define _DRIVER_SNDIO_H_
+
+struct driver_sndio {
+ struct sio_hdl * handle;
+};
+
+int driver_sndio_open(struct roar_vio_calls * inst, char * device, struct roar_audio_info * info, int fh);
+
+#endif
+
+//ll