Index: libroar/Makefile
===================================================================
--- libroar/Makefile	(revision 1643)
+++ libroar/Makefile	(revision 1733)
@@ -10,5 +10,6 @@
 INCLUDE = -I../include -I../include/libroar
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g $(SHARED) $(LDPATH) $(lib_dnet) $(lib_wsock32) $(lib_ws2_32) $(lib_ssl) $(lib_sendfile)
+LDFLAGS = -g $(SHARED) $(LDPATH)
+LIBS    = $(lib_dnet) $(lib_wsock32) $(lib_ws2_32) $(lib_ssl) $(lib_sendfile)
 
 all: ${TARGETS}
@@ -20,5 +21,5 @@
 
 libroar.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroar.so ${OBJS}
+	${CC} ${LDFLAGS} -o libroar.so ${OBJS} ${LIBS}
 libroar.a: ${OBJS}
 	${AR} cru libroar.a ${OBJS}
Index: libroararts/Makefile
===================================================================
--- libroararts/Makefile	(revision 1629)
+++ libroararts/Makefile	(revision 1733)
@@ -7,5 +7,6 @@
 INCLUDE = -I../include -I../include/libroarpulse
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g -lroar $(LDPATH) -L../lib/
+LDFLAGS = -g $(LDPATH) -L../lib/
+LIBS    = -lroar
 
 all: ${TARGETS}
@@ -18,3 +19,3 @@
 	cp libroarartsc.so libartsc.so
 libroarartsc.so: ${OBJS}
-	${CC} ${LDFLAGS} $(SHARED) -o libroarartsc.so ${OBJS}
+	${CC} ${LDFLAGS} $(SHARED) -o libroarartsc.so ${OBJS} ${LIBS}
Index: libroardsp/Makefile
===================================================================
--- libroardsp/Makefile	(revision 1626)
+++ libroardsp/Makefile	(revision 1733)
@@ -11,5 +11,6 @@
 INCLUDE = -I../include -I../include/libroardsp
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g $(SHARED) -L../lib/ $(LDPATH) $(lib_dnet) $(lib_m) -lroar
+LDFLAGS = -g $(SHARED) -L../lib/ $(LDPATH)
+LIBS    = $(lib_dnet) $(lib_m) -lroar
 
 all: ${TARGETS}
@@ -21,5 +22,5 @@
 
 libroardsp.so: ${OBJS} $(FILTER) $(OLDROAR)
-	${CC} ${LDFLAGS} -o libroardsp.so ${OBJS} $(FILTER) $(OLDROAR)
+	${CC} ${LDFLAGS} -o libroardsp.so ${OBJS} $(FILTER) $(OLDROAR) $(LIBS)
 libroardsp.a: ${OBJS} $(FILTER) $(OLDROAR)
 	${AR} cru libroardsp.a ${OBJS} $(FILTER) $(OLDROAR)
Index: libroaresd/Makefile
===================================================================
--- libroaresd/Makefile	(revision 1389)
+++ libroaresd/Makefile	(revision 1733)
@@ -7,5 +7,6 @@
 INCLUDE = -I../include -I../include/libroaresd
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g $(SHARED) -lroar $(LDPATH) -L../lib/
+LDFLAGS = -g $(SHARED) $(LDPATH) -L../lib/
+LIBS    = -lroar
 
 all: ${TARGETS}
@@ -16,3 +17,3 @@
 
 libroaresd.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroaresd.so ${OBJS}
+	${CC} ${LDFLAGS} -o libroaresd.so ${OBJS} ${LIBS}
Index: libroarpulse/Makefile
===================================================================
--- libroarpulse/Makefile	(revision 1389)
+++ libroarpulse/Makefile	(revision 1733)
@@ -7,5 +7,6 @@
 INCLUDE = -I../include -I../include/libroarpulse
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g -lroar $(LDPATH) -L../lib/
+LDFLAGS = -g $(LDPATH) -L../lib/
+LIBS    = -lroar
 
 all: ${TARGETS}
@@ -16,5 +17,5 @@
 
 libroarpulse.so: ${OBJS}
-	${CC} ${LDFLAGS} $(SHARED) -o libroarpulse.so ${OBJS}
+	${CC} ${LDFLAGS} $(SHARED) -o libroarpulse.so ${OBJS} ${LIBS}
 
 libroarpulseinfo: libroarpulseinfo.o
Index: libroarsndio/Makefile
===================================================================
--- libroarsndio/Makefile	(revision 1560)
+++ libroarsndio/Makefile	(revision 1733)
@@ -7,5 +7,6 @@
 INCLUDE = -I../include -I../include/libroarsndio
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g $(SHARED) -lroar $(LDPATH) -L../lib/
+LDFLAGS = -g $(SHARED) $(LDPATH) -L../lib/
+LIBS    = -lroar
 
 all: ${TARGETS}
@@ -16,3 +17,3 @@
 
 libroarsndio.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroarsndio.so ${OBJS}
+	${CC} ${LDFLAGS} -o libroarsndio.so ${OBJS} ${LIBS}
Index: libroaryiff/Makefile
===================================================================
--- libroaryiff/Makefile	(revision 1389)
+++ libroaryiff/Makefile	(revision 1733)
@@ -7,5 +7,6 @@
 INCLUDE = -I../include -I../include/libroaryiff
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH) $(SHARED_CF) $(fPIC)
-LDFLAGS = -g $(SHARED) -lroar $(LDPATH) -L../lib/
+LDFLAGS = -g $(SHARED) $(LDPATH) -L../lib/
+LIBS    = -lroar
 
 all: ${TARGETS}
@@ -16,3 +17,3 @@
 
 libroaryiff.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroaryiff.so ${OBJS}
+	${CC} ${LDFLAGS} -o libroaryiff.so ${OBJS} ${LIBS}
Index: roard/Makefile
===================================================================
--- roard/Makefile	(revision 1646)
+++ roard/Makefile	(revision 1733)
@@ -11,5 +11,6 @@
 INCLUDE = -I../include -I./include
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE) $(INCPATH)
-LDFLAGS = -g -L../lib/ $(LDPATH) -lroar -lroardsp $(lib_esd) $(lib_ossaudio) $(lib_ao) $(lib_shout) $(lib_vorbisfile) $(lib_vorbisenc) $(lib_vorbis) $(lib_celt) $(lib_fishsound) $(lib_speex) $(lib_speexdsp) $(lib_oggz) $(lib_sndfile) $(lib_m) $(lib_sndio) $(lib_ogg) $(lib_socket)
+LDFLAGS = -g -L../lib/ $(LDPATH)
+LIBS    = -lroar -lroardsp $(lib_esd) $(lib_ossaudio) $(lib_ao) $(lib_shout) $(lib_vorbisfile) $(lib_vorbisenc) $(lib_vorbis) $(lib_celt) $(lib_fishsound) $(lib_speex) $(lib_speexdsp) $(lib_oggz) $(lib_sndfile) $(lib_m) $(lib_sndio) $(lib_ogg) $(lib_socket)
 
 all: ${TARGETS}
@@ -21,2 +22,3 @@
 
 roard: ${OBJ} ${DRV} ${CF}
+	${CC} ${LDFLAGS} -o roard ${OBJ} ${DRV} ${CF} ${LIBS}
Index: roarfish/Makefile
===================================================================
--- roarfish/Makefile	(revision 726)
+++ roarfish/Makefile	(revision 1733)
@@ -6,5 +6,6 @@
 INCLUDE = -I../include -I./include
 CFLAGS += -g -Wall -O2 $(DEFINES) $(INCLUDE)
-LDFLAGS = -g -L../lib/ $(LDPATH) -lroar -lfishsound -loggz
+LDFLAGS = -g -L../lib/ $(LDPATH)
+LIBS    = -lroar -lfishsound -loggz
 
 all: ${TARGETS}
@@ -15,2 +16,3 @@
 
 roarfish: ${OBJ}
+	${CC} ${LDFLAGS} -o roarfish ${OBJ} ${LIBS}