Index: Makefile
===================================================================
--- Makefile	(revision 1737)
+++ Makefile	(revision 2050)
@@ -30,6 +30,6 @@
 install: prep-install-dirs
 	cp $(cp_v) lib/roar*     $(PREFIX_BIN)
-	cp $(cp_v) lib/lib*.so*  $(PREFIX_LIB)
-	sh -c 'cd lib; for file in $(COMP_LIB); do for i in "" .{0,1}; do ln -fs $(PREFIX_LIB)/$$file.so $(PREFIX_COMP)/`echo $$file | sed s/roar//`.so$$i; done; done'
+	cp $(cp_v) lib/lib*$(SHARED_SUFFIX)*  $(PREFIX_LIB)
+	sh -c 'cd lib; for file in $(COMP_LIB); do for i in "" .{0,1}; do ln -fs $(PREFIX_LIB)/$$file$(SHARED_SUFFIX) $(PREFIX_COMP)/`echo $$file | sed s/roar//`$(SHARED_SUFFIX)$$i; done; done'
 	sh -c 'for file in include/roar* include/lib*; do cp $(cp_v) -r $$file $(PREFIX_INC)/; done'
 	cd doc; make install; cd ..
@@ -38,6 +38,6 @@
 semi-install: prep-install-dirs
 	sh -c 'for file in lib/roar*;    do ln -fs `pwd`/$$file $(PREFIX_BIN)/; done'
-	sh -c 'for file in lib/lib*.so*; do ln -fs `pwd`/$$file $(PREFIX_LIB)/; done'
-	sh -c 'cd lib; for file in $(COMP_LIB); do for i in "" .{0,1}; do ln -fs `pwd`/$$file.so $(PREFIX_COMP)/`echo $$file | sed s/roar//`.so$$i; done; done'
+	sh -c 'for file in lib/lib*$(SHARED_SUFFIX)*; do ln -fs `pwd`/$$file $(PREFIX_LIB)/; done'
+	sh -c 'cd lib; for file in $(COMP_LIB); do for i in "" .{0,1}; do ln -fs `pwd`/$$file$(SHARED_SUFFIX) $(PREFIX_COMP)/`echo $$file | sed s/roar//`$(SHARED_SUFFIX)$$i; done; done'
 	sh -c 'for file in include/roar* include/lib*; do ln -fs `pwd`/$$file $(PREFIX_INC)/; done'
 	cd doc; make semi-install; cd ..
Index: libroar/Makefile
===================================================================
--- libroar/Makefile	(revision 2037)
+++ libroar/Makefile	(revision 2050)
@@ -1,7 +1,7 @@
 include ../Makefile.conf
 
-SLIB=libroar.so
+SLIB=libroar$(SHARED_SUFFIX)
 
-TARGETS=libroar.so libroar.a
+TARGETS=$(SLIB) libroar.a
 VIO=vio.o vio_cmd.o vio_ops.o vio_magic.o vio_pipe.o vio_socket.o vio_bio.o vio_stack.o vio_proto.o vio_dstr.o vio_select.o
 OBJS=libroar.o basic.o stream.o simple.o auth.o socket.o ctl.o buffer.o meta.o file.o acl.o cdrom.o pinentry.o sshaskpass.o $(VIO) stack.o slp.o
@@ -21,6 +21,6 @@
 new: clean all
 
-libroar.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroar.so ${OBJS} ${LIBS}
+$(SLIB): ${OBJS}
+	${CC} ${LDFLAGS} -o $(SLIB) ${OBJS} ${LIBS}
 libroar.a: ${OBJS}
 	${AR} cru libroar.a ${OBJS}
Index: libroardsp/Makefile
===================================================================
--- libroardsp/Makefile	(revision 1773)
+++ libroardsp/Makefile	(revision 2050)
@@ -1,7 +1,7 @@
 include ../Makefile.conf
 
-SLIB=libroardsp.so
+SLIB=libroardsp$(SHARED_SUFFIX)
 
-TARGETS=libroardsp.so libroardsp.a
+TARGETS=$(SLIB) libroardsp.a
 OBJS=libroardsp.o convert.o midside.o poly.o filter.o filterchain.o alaw.o mulaw.o
 OLDROAR=midi.o
@@ -21,6 +21,6 @@
 new: clean all
 
-libroardsp.so: ${OBJS} $(FILTER) $(OLDROAR)
-	${CC} ${LDFLAGS} -o libroardsp.so ${OBJS} $(FILTER) $(OLDROAR) $(LIBS)
+$(SLIB): ${OBJS} $(FILTER) $(OLDROAR)
+	${CC} ${LDFLAGS} -o $(SLIB) ${OBJS} $(FILTER) $(OLDROAR) $(LIBS)
 libroardsp.a: ${OBJS} $(FILTER) $(OLDROAR)
 	${AR} cru libroardsp.a ${OBJS} $(FILTER) $(OLDROAR)
Index: libroarlight/Makefile
===================================================================
--- libroarlight/Makefile	(revision 2037)
+++ libroarlight/Makefile	(revision 2050)
@@ -1,7 +1,7 @@
 include ../Makefile.conf
 
-SLIB=libroarlight.so
+SLIB=libroarlight$(SHARED_SUFFIX)
 
-TARGETS=libroarlight.so libroarlight.a
+TARGETS=$(SLIB) libroarlight.a
 OBJS=libroarlight.o colors.o roardmx.o pwm.o
 
@@ -20,6 +20,6 @@
 new: clean all
 
-libroarlight.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroarlight.so ${OBJS} $(LIBS)
+$(SLIB): ${OBJS}
+	${CC} ${LDFLAGS} -o $(SLIB) ${OBJS} $(LIBS)
 libroarlight.a: ${OBJS}
 	${AR} cru libroarlight.a ${OBJS}
Index: libroarmidi/Makefile
===================================================================
--- libroarmidi/Makefile	(revision 2037)
+++ libroarmidi/Makefile	(revision 2050)
@@ -1,7 +1,7 @@
 include ../Makefile.conf
 
-SLIB=libroarmidi.so
+SLIB=libroarmidi$(SHARED_SUFFIX)
 
-TARGETS=libroarmidi.so libroarmidi.a
+TARGETS=$(SLIB) libroarmidi.a
 OBJS=libroarmidi.o
 
@@ -20,6 +20,6 @@
 new: clean all
 
-libroarmidi.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroarmidi.so ${OBJS} $(LIBS)
+$(SLIB): ${OBJS}
+	${CC} ${LDFLAGS} -o $(SLIB) ${OBJS} $(LIBS)
 libroarmidi.a: ${OBJS}
 	${AR} cru libroarmidi.a ${OBJS}
Index: libroarsndio/Makefile
===================================================================
--- libroarsndio/Makefile	(revision 1773)
+++ libroarsndio/Makefile	(revision 2050)
@@ -1,5 +1,5 @@
 include ../Makefile.conf
 
-SLIB=libroarsndio.so
+SLIB=libroarsndio$(SHARED_SUFFIX)
 
 TARGETS=$(SLIB) libroarsndio.a
@@ -19,6 +19,6 @@
 new: clean all
 
-libroarsndio.so: ${OBJS}
-	${CC} ${LDFLAGS} -o libroarsndio.so ${OBJS} ${LIBS}
+$(SLIB): ${OBJS}
+	${CC} ${LDFLAGS} -o $(SLIB) ${OBJS} ${LIBS}
 libroarsndio.a: ${OBJS}
 	${AR} cru libroarsndio.a ${OBJS}