Index: roarclients/roarcatpassfh.c
===================================================================
--- roarclients/roarcatpassfh.c	(revision 2230)
+++ roarclients/roarcatpassfh.c	(revision 2292)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
@@ -78,5 +78,5 @@
  }
 
- if ( roar_simple_connect(&con, server, "roarcatad") == -1 ) {
+ if ( roar_simple_connect(&con, server, "roarcatpassfh") == -1 ) {
   ROAR_DBG("roar_simple_play(*): roar_simple_connect() faild!");
   return 1;
Index: roarclients/roarcatplay.c
===================================================================
--- roarclients/roarcatplay.c	(revision 1775)
+++ roarclients/roarcatplay.c	(revision 2292)
@@ -1,6 +1,6 @@
-//roarcat.c:
+//roarcatplay.c:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarcatsendfile.c
===================================================================
--- roarclients/roarcatsendfile.c	(revision 669)
+++ roarclients/roarcatsendfile.c	(revision 2292)
@@ -1,6 +1,6 @@
-//roarcat.c:
+//roarcatsendfile.c:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
@@ -81,5 +81,5 @@
  }
 
- if ( (fh = roar_simple_play(rate, channels, bits, codec, server, "roarcat")) == -1 ) {
+ if ( (fh = roar_simple_play(rate, channels, bits, codec, server, "roarcatsendfile")) == -1 ) {
   fprintf(stderr, "Error: can not start playback\n");
   return 1;
Index: roarclients/roarcatvio.c
===================================================================
--- roarclients/roarcatvio.c	(revision 2230)
+++ roarclients/roarcatvio.c	(revision 2292)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
@@ -50,5 +50,5 @@
  char * k;
  int    i;
- char * name = "roarcat";
+ char * name = "roarcatvio";
  struct roar_vio_calls file, stream;
  struct roar_vio_defaults def;
Index: roarclients/roarfctest.c
===================================================================
--- roarclients/roarfctest.c	(revision 1133)
+++ roarclients/roarfctest.c	(revision 2292)
@@ -1,6 +1,6 @@
-//roarsin.c:
+//roarfctest.c:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
Index: roarclients/roarfilt.c
===================================================================
--- roarclients/roarfilt.c	(revision 1635)
+++ roarclients/roarfilt.c	(revision 2292)
@@ -2,5 +2,5 @@
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,
@@ -233,5 +233,5 @@
  }
 
- if ( (fh = roar_simple_filter(rate, channels, bits, codec, server, "roarifilt")) == -1 ) {
+ if ( (fh = roar_simple_filter(rate, channels, bits, codec, server, "roarfilt")) == -1 ) {
   fprintf(stderr, "Error: can not start playback\n");
   return 1;
Index: roarclients/roarmon.c
===================================================================
--- roarclients/roarmon.c	(revision 2241)
+++ roarclients/roarmon.c	(revision 2292)
@@ -1,3 +1,3 @@
-//roarcat.c:
+//roarmon.c:
 
 /*
Index: roarclients/roarphone.c
===================================================================
--- roarclients/roarphone.c	(revision 2282)
+++ roarclients/roarphone.c	(revision 2292)
@@ -1,3 +1,3 @@
-//roarbidir.c:
+//roarphone.c:
 
 /*
@@ -56,5 +56,5 @@
 
 void usage (void) {
- printf("roarcat [OPTIONS]...\n");
+ printf("roarphone [OPTIONS]...\n");
 
  printf("\nOptions:\n\n");
Index: roarclients/roarshout.c
===================================================================
--- roarclients/roarshout.c	(revision 2163)
+++ roarclients/roarshout.c	(revision 2292)
@@ -31,5 +31,5 @@
 
 void usage (void) {
- printf("roarmon [OPTIONS]... [address [port [password [mountpoint]]]\n");
+ printf("roarshout [OPTIONS]... [address [port [password [mountpoint]]]\n");
 
  printf("\nRoarAudio Options:\n\n");
Index: roarclients/roarvumeter.c
===================================================================
--- roarclients/roarvumeter.c	(revision 1633)
+++ roarclients/roarvumeter.c	(revision 2292)
@@ -1,6 +1,6 @@
-//roarcat.c:
+//roarvumeter.c:
 
 /*
- *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008
+ *      Copyright (C) Philipp 'ph3-der-loewe' Schafft - 2008, 2009
  *
  *  This file is part of roarclients a part of RoarAudio,